<?
  #  This program is free software; you can redistribute it and/or modify
  #  it under the terms of the GNU General Public License as published by
  #  the Free Software Foundation; version 2 of the License.
  #
  #  This program is distributed in the hope that it will be useful,
  #  but WITHOUT ANY WARRANTY; without even the implied warranty of
  #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #  GNU General Public License for more details.
  #
  #  You should have received a copy of the GNU General Public License
  #  along with this program; if not, write to the Free Software
  #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  # $Id: ce_get_vars.inc,v 2.6 2009-11-17 03:22:22 peter Exp $

function ce_get_cgi_var($var)
{
  global $HTTP_GET_VARS;
  global $HTTP_POST_VARS;

  ce_debug(98,"\n<!-- Checking for $var in GET vars -->");
  if(isset($HTTP_GET_VARS[$var]))    return stripslashes($HTTP_GET_VARS[$var]);
  ce_debug(98,"\n<!-- Checking for $var in POST vars -->");
  if(isset($HTTP_POST_VARS[$var]))   return stripslashes($HTTP_POST_VARS[$var]);
  ce_debug(60,"\n<!-- $var not found (cgi) -->");
  return NULL;
}

function ce_get_var($var)
{
  global $HTTP_COOKIE_VARS;

  ce_debug(98,"\n<!-- Checking for $var in CGI vars -->",__FILE__,__LINE__);
  $val=ce_get_cgi_var($var);
  if( isset($val) ) return $val;
  ce_debug(98,"\n<!-- Checking for $var in COOKIES -->",__FILE__,__LINE__);
  if(isset($HTTP_COOKIE_VARS[$var])) return $HTTP_COOKIE_VARS[$var];
  ce_debug(60,"\n<!-- $var not found -->",__FILE__,__LINE__);
  return NULL;
}

while (list ($key, $val) = each ($HTTP_POST_VARS))
 { ce_debug(80,"\n<!-- POST: $key = '$val' -->",__FILE__,__LINE__); }
while (list ($key, $val) = each ($HTTP_GET_VARS))
 { ce_debug(80,"\n<!-- GET: $key = '$val' -->",__FILE__,__LINE__); }
while (list ($key, $val) = each ($HTTP_COOKIE_VARS))
 { ce_debug(80,"\n<!-- COOKIE: $key = '$val' -->",__FILE__,__LINE__); }

if( isset($ce_clone_id         )) { ce_warn("ce_clone_id          already set to $ce_clone_id         ",__FILE__,__LINE__);}
$ce_clone_id         = ce_get_cgi_var("ce_clone_id");
if( isset($ce_commit_button    )) { ce_warn("ce_commit_button     already set to $ce_commit_button    ",__FILE__,__LINE__);}
$ce_commit_button    = ce_get_cgi_var("ce_commit_button");
if( isset($ce_purge_id         )) { ce_warn("ce_purge_id          already set to $ce_purge_id         ",__FILE__,__LINE__);}
$ce_purge_id         = ce_get_cgi_var("ce_purge_id");
if( isset($ce_purge_button     )) { ce_warn("ce_purge_button      already set to $ce_purge_button     ",__FILE__,__LINE__);}
$ce_purge_button     = ce_get_cgi_var("ce_purge_button");
if( isset($ce_edit_id          )) { ce_warn("ce_edit_id           already set to $ce_edit_id          ",__FILE__,__LINE__);}
$ce_edit_id          = ce_get_cgi_var("ce_edit_id");
if( isset($ce_edit_display_item)) { ce_warn("ce_edit_display_item already set to $ce_edit_display_item",__FILE__,__LINE__);}
$ce_edit_display_item= ce_get_cgi_var("ce_edit_display_item");
if( isset($ce_fulledit_button  )) { ce_warn("ce_fulledit_button   already set to $ce_fulledit_button  ",__FILE__,__LINE__);}
$ce_fulledit_button  = ce_get_cgi_var("ce_fulledit_button");
if( isset($ce_new_abstract     )) { ce_warn("ce_new_abstract      already set to $ce_new_abstract     ",__FILE__,__LINE__);}
$ce_new_abstract     = ce_get_cgi_var("ce_new_abstract");
if( isset($ce_new_button       )) { ce_warn("ce_new_button        already set to $ce_new_button       ",__FILE__,__LINE__);}
$ce_new_button       = ce_get_cgi_var("ce_new_button");
if( isset($ce_draft_button     )) { ce_warn("ce_draft_button      already set to $ce_draft_button     ",__FILE__,__LINE__);}
$ce_draft_button     = ce_get_cgi_var("ce_draft_button");

if( isset($ce_new_data         )) { ce_warn("ce_new_data          already set to $ce_new_data         ",__FILE__,__LINE__);}
$ce_new_data         = ce_get_cgi_var("ce_new_data");
if( isset($ce_new_content_type )) { ce_warn("ce_new_content_type  already set to $ce_new_content_type ",__FILE__,__LINE__);}
$ce_new_content_type = ce_get_cgi_var("ce_new_content_type");
if( isset($ce_new_layout_path  )) { ce_warn("ce_new_layout_path   already set to $ce_new_layout_path  ",__FILE__,__LINE__);}
$ce_new_layout_path  = ce_get_cgi_var("ce_new_layout_path");
if( isset($ce_new_locale       )) { ce_warn("ce_new_locale        already set to $ce_new_locale       ",__FILE__,__LINE__);}
$ce_new_locale       = ce_get_cgi_var("ce_new_locale");
if( isset($ce_new_name         )) { ce_warn("ce_new_name          already set to $ce_new_name         ",__FILE__,__LINE__);}
$ce_new_name         = ce_get_cgi_var("ce_new_name");
if( isset($ce_new_author       )) { ce_warn("ce_new_author        already set to $ce_new_author       ",__FILE__,__LINE__);}
$ce_new_author       = ce_get_cgi_var("ce_new_author");
if( isset($ce_new_path         )) { ce_warn("ce_new_path          already set to $ce_new_path         ",__FILE__,__LINE__);}
$ce_new_path         = ce_get_cgi_var("ce_new_path");
if( isset($ce_new_state        )) { ce_warn("ce_new_state         already set to $ce_new_state        ",__FILE__,__LINE__);}
$ce_new_state        = ce_get_cgi_var("ce_new_state");

if( isset($ce_state            )) { ce_warn("ce_state             already set to $ce_state            ",__FILE__,__LINE__);}
$ce_state            = ce_get_cgi_var("ce_state");
if( isset($orig_http_referer   )) { ce_warn("orig_http_referer    already set to $orig_http_referer   ",__FILE__,__LINE__);}
$orig_http_referer   = ce_get_cgi_var("orig_http_referer");

if( isset($ce_return_label     )) { ce_warn("ce_return_label      already set to $ce_return_label     ",__FILE__,__LINE__);}
$ce_return_label   = ce_get_cgi_var("ce_return_label");

if(!isset($ce_debug            )) { $ce_debug            = ce_get_var("ce_debug");                }
if(!isset($ce_debuglevel       )) { $ce_debuglevel       = ce_get_var("ce_debuglevel");           }
if(!isset($ce_edit             )) { $ce_edit             = ce_get_var("ce_edit") ;                }
if(!isset($ce_showborder       )) { $ce_showborder       = ce_get_var("ce_showborder");           } 
if(!isset($ce_showdraft        )) { $ce_showdraft        = ce_get_var("ce_showdraft");            } 

if( 0 == $ce_edit       ) unset( $ce_edit       ) ;
if( 0 == $ce_debug      ) unset( $ce_debug      ) ;
if( 0 == $ce_showborder ) unset( $ce_showborder ) ;
if( 0 == $ce_showdraft  ) unset( $ce_showdraft  ) ;

# if(!isset($ce_new_upload       )) { $ce_new_upload       = ce_get_cgi_var("ce_new_upload");     }

# $ce_new_upload_name = $HTTP_POST_FILES['ce_new_upload']['name']
$ce_new_upload_type = $HTTP_POST_FILES['ce_new_upload']['type'] ;
$ce_new_upload_size = $HTTP_POST_FILES['ce_new_upload']['size'] ;
$ce_new_upload      = $HTTP_POST_FILES['ce_new_upload']['tmp_name'] ;

?>
