<? 
  //  This program is free software; you can redistribute it and/or modify
  //  it under the terms of the GNU General Public License as published by
  //  the Free Software Foundation; version 2 of the License.
  //
  //  This program is distributed in the hope that it will be useful,
  //  but WITHOUT ANY WARRANTY; without even the implied warranty of
  //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  //  GNU General Public License for more details.
  //
  //  You should have received a copy of the GNU General Public License
  //  along with this program; if not, write to the Free Software
  //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  // $Id: ce_include.inc,v 2.4 2009-11-16 13:57:23 peter Exp $

# I recommend to pass $tag_var by reference - we cannot force this here by
# defaulte, because we need to call it with ...,array()) when no ce tag
# variables are available

function ce_include($mode,&$i,$tag_var)
{
   global $ce_locale;   
   global $ce_edit;
   global $HTTP_SERVER_VARS;

   global $ce_edit_id;
   global $ce_edit_display_item;
   global $ce_clone_id;
   global $ce_id;
   global $ce_new_data;
   global $ce_prefix;
   global $ce_edit_prefix;
   global $ce_list_path;
   global $ce_output_ok;
   global $ce_showborder;
   global $ce_showdraft;
   global $ce_show_clonelink;
   global $ce_request;
   global $ce_is_authenticated;

   static $global_links_displayed;

   static $log_prefix="";

   if( !isset($i) )
	{
	  ce_error("ce_include called with undefined item!");
	  return FALSE;
	}

   if( "PAGE" == $mode ) $i->is_main=TRUE;

   $log_prefix.=" ";

   $edit_rows=$tag_var["EDIT_ROWS"];
   $edit_cols=$tag_var["EDIT_COLS"];

   ce_debug(5,"\n<!-- ce_include():".$log_prefix."new item for '$i->path' ($mode,$i->display_item_no()) -->");

   ce_debug(5,"\n<!-- ce_include():".$log_prefix."is main? '".($i->is_main ? "TRUE" : "FALSE")."' -->");


  if( empty($ce_edit_id) 
      AND $mode == "PAGE"
      AND substr(strtolower($i->content_type),0,9) != "text/x-ce"
      AND $i->content_type != "application/x-httpd-php" 
      //AND ( empty($i->layout_ref)
      //      OR $HTTP_SERVER_VARS['HTTP_REFERER'] == "http://".$HTTP_SERVER_VARS['SERVER_NAME'].$HTTP_SERVER_VARS['REQUEST_URI'] )
      ) 
    { 
      header("Content-type: $i->content_type");
      print($i->data);
      exit();
    }

  if( $mode != "PAGE"
      AND substr(strtolower($i->content_type),0,6) == "image/") 
    { 
      $ce_output_ok=TRUE;
      ce_debug(5,"\n<!-- ce_include():".$log_prefix."PATH_INFO= '".$HTTP_SERVER_VARS['PATH_INFO']."' -->");

      $pagedir=preg_replace(":/[^/]*$:","/",$ce_prefix.$HTTP_SERVER_VARS['PATH_INFO']);
      ce_debug(5,"\n<!-- ce_include():".$log_prefix."\$pagedir= '$pagedir' -->");
      $imgpath=preg_replace(":^".$pagedir.":","",$ce_prefix.$i->path);
      $i->data='<IMG SRC="'.$imgpath.'"
                     ALT="[Bild:'.$i->name.']"
                     TITLE="'.$i->abstract.'">';
    }

  $ce_output_ok=TRUE;

  // find the most outer layout and start with that instead of given item ($i)

  while( ( "CONTENT" != $mode ) 
         && ( "ABSTRACT" != $mode) 
         && !empty($i->layout_ref) )
    {
      ce_debug(5,"\n<!-- found layout ".$i->layout_ref->name." -->");
      $i =& $i->layout_ref ;
    }
 
  if( isset($ce_edit) 
      && (! (isset($ce_edit_id) 
             || isset($ce_edit_display_item)) ) ) { $ce_showlinks=TRUE; }
  if( $ce_showborder ) { print "<TABLE BORDER=1><TR><TD>"; }

  ce_debug(5,"\n<!-- ce_include():".$log_prefix."BEGIN '$i->name' ($mode, $i->display_item_no()) -->");
  ce_debug(5,"\n<!-- ce_include():".$log_prefix."is main? '$i->is_main' -->");

  ce_debug(17,"\n<!-- ce_include():".$log_prefix."HTTP_REFERER    :".$HTTP_SERVER_VARS['HTTP_REFERER'   ]   ."-->");
  ce_debug(17,"\n<!-- ce_include()                   http://".$HTTP_SERVER_VARS['SERVER_NAME'].
                                                                                     $HTTP_SERVER_VARS['REQUEST_URI']."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."REQUEST_METHOD  :".$HTTP_SERVER_VARS['REQUEST_METHOD ']."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."REQUEST_URI     :".$HTTP_SERVER_VARS['REQUEST_URI'    ]."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SCRIPT_FILENAME :".$HTTP_SERVER_VARS['SCRIPT_FILENAME']."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SCRIPT_NAME     :".$HTTP_SERVER_VARS['SCRIPT_NAME'    ]."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SERVER_ADDR     :".$HTTP_SERVER_VARS['SERVER_ADDR'    ]."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SERVER_ADMIN    :".$HTTP_SERVER_VARS['SERVER_ADMIN'   ]."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SERVER_NAME     :".$HTTP_SERVER_VARS['SERVER_NAME'    ]."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SERVER_PORT     :".$HTTP_SERVER_VARS['SERVER_PORT'    ]."-->");
  ce_debug(17,"\n<!-- ce_include():".$log_prefix."SERVER_PROTOCOL :".$HTTP_SERVER_VARS['SERVER_PROTOCOL']."-->");


   if( ( $ce_edit_id 
         AND ($ce_edit_id == $i->id)
         AND (TRUE == $i->is_main)
 )
       OR ( $ce_edit_display_item == $i->display_item_no() ) )
   {
      ?>
        <DIV ALIGN="left">
        <FORM
         ACTION="<? print $ce_edit_prefix.$HTTP_SERVER_VARS['PATH_INFO'];?>"
         ENCTYPE="multipart/form-data" 
         METHOD="POST">
          <? if( "DRAFT" == $i->state) { ?>
          <INPUT TYPE="submit" name="ce_commit_button" value="Commit Draft">
          <? } else { ?>
          <INPUT TYPE="submit" name="ce_draft_button" value="Commit Draft">
          <INPUT TYPE="submit" name="ce_commit_button" value="Commit">
          <? } ?>
          <INPUT TYPE="submit" name="ce_fulledit_button" value="Full Edit">
          <!-- Editing <? print $i->path." (".$i->locale.")";?> -->
       <? if($mode == "ABSTRACT" ) { 
           empty($edit_rows) && $edit_rows=10 ; 
           empty($edit_cols) && $edit_cols=80 ; 
           ?> 
          [Abstract: <? print $i->name." (".$i->locale.")";?>]<br>
            <TEXTAREA WRAP=virtual 
                      NAME=ce_new_abstract 
                      ROWS=<? print $edit_rows; ?> 
                      COLS=<? print $edit_cols ?> ><?
             echo htmlentities($i->abstract);
          ?></TEXTAREA>
        <? } else {
           empty($edit_rows) && $edit_rows=40 ; 
           empty($edit_cols) && $edit_cols=120 ; 
           ?>
          [<? print $i->name." (".$i->locale.")";?>]<br>
        <?if( substr(strtolower($i->content_type),0,5) == "text/"
             OR $i->content_type == "application/x-httpd-php" ) { ?>
          <TEXTAREA WRAP=virtual 
                    NAME=ce_new_data 
                    ROWS=<? print $edit_rows ?>
                    COLS=<? print $edit_cols ?>><?
             echo htmlentities($i->data);
          ?></TEXTAREA>
        <? } else { ?>
          <INPUT TYPE="hidden" name="ce_new_path" value="<? print $i->path; ?>">
      <?   if( substr(strtolower($i->content_type),0,6) == "image/") 
             { print('<IMG SRC="'.$ce_prefix.$i->path.'"><br>'."\n");  } ?>
          <INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="100000">
             Upload file: <INPUT NAME="ce_new_upload" TYPE="file">

      <? } } ?>
          <INPUT TYPE="hidden" name="ce_edit_id" value="<? print $i->id; ?>">
          <INPUT TYPE="hidden" name="ce_state"   value="<? print $i->state; ?>">
          <INPUT TYPE="hidden" name="ce_path"    value="<? print $i->path; ?>">
        </FORM>
        </DIV>
       <?
     if(($ce_showborder)){print "</TD></TR><TR><TD>";}
# // to show edit form only once
#           $ce_edit_id=NULL;
   }
  else
   {
     if( isset($ce_edit) && (!$global_links_displayed) )
       {
         print '<table width="100%"><tr valign="top"><td width="25%" align="left">';
	 print '<small>'.( $ce_is_authenticated ? 'Logged in as' : 'User' ).': '.$_SERVER['PHP_AUTH_USER'].'</small>';
         print '</td><td width="50%" align="center">';
         print "<small><A HREF=\"$ce_prefix".$HTTP_SERVER_VARS['PATH_INFO']."\">[view final]</A></small>" ;
         print "<small><A HREF=\"$ce_edit_prefix?ce_edit=\">[add new]</A></small>" ;
         print '<small><A HREF="'.ce_prefix(TRUE).$HTTP_SERVER_VARS['PATH_INFO']
                                 .'?ce_edit_id='.$ce_request->id.'">'
                                 .'[edit &quot;'.$ce_request->name.'&quot;]</A></small>';
         print "<small><A HREF=\"$ce_list_path\">[list all]</A></small>" ;
         print "<br>";
         print "[Draft:    ".( $ce_showdraft  ? "Yes" : "No")."] ";
         print "[Structure:".( $ce_showborder ? "Yes" : "No")."] ";
         print "[Links:    ".( $ce_showlinks  ? "Yes" : "No")."] ";
         print '</td><td width="25%" align="right">';
         if ( $ce_is_authenticated ) print '<small><A HREF="'.ce_prefix(TRUE).'/logoff.php?'.$_SERVER['PHP_AUTH_USER'].'">[logout]</A></small>' ;
         print '</td></tr></table>';
         $global_links_displayed="yes";
         if( $ce_showborder ) {print "</TD></TR><TR><TD>";}
       }
     if( $mode == "ABSTRACT" ) 
       print $i->abstract;
     else
       ce_parse($i);
     if(($ce_showborder))                      {print "</TD></TR><TR><TD>";}
     if(isset($ce_showlinks) && ! $i->edit_link_shown)
       {
         if( ! $ce_showborder ) { print "<BR>\n"; }
         print '<small><font color="blue">[';
         if( $ce_show_clonelink )
           print "<A HREF=\"$ce_edit_prefix"
             .$HTTP_SERVER_VARS['PATH_INFO']
             ."?ce_clone_id=".$i->id."\">clone</A> | " ;
         if( "DRAFT" == $i->state )
           print "<A HREF=\"$ce_edit_prefix"
             .$HTTP_SERVER_VARS['PATH_INFO']
             ."?ce_edit_id=".$i->id."&ce_new_state=OK&ce_commit_button=publish\">publish</A> | " ;
         print "<A HREF=\"$ce_edit_prefix"
           .$HTTP_SERVER_VARS['PATH_INFO']
           ."?ce_edit_display_item=".$i->display_item_no()."\">"
           ."edit"
           ."</A> " ;
         print "&quot;".$i->name."&quot;" ;
         if( $mode == "ABSTRACT" )
           print "(abstract)";
         print "]</font></small>" ;
       }
   }
  if( $ce_showborder && ! isset($ce_showlinks) ){ print $i->name;}
  if( $ce_showborder ){ print "</TD></TR></TABLE>";}
  ce_debug(5,"\n<!-- ce_include():".$log_prefix."END ".$i->name." (".$mode.",".$i->display_item_no().") -->\n");
  $i->display_item_no_spent();
  $log_prefix=substr($log_prefix,0,-1);
}
?>
