# $Id: cruisedit.sql,v 2.2 2007-06-02 13:46:36 peter Exp $

CREATE TABLE `ce_items` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `parent` bigint(20) unsigned NOT NULL default '0',
  `locale` varchar(10) NOT NULL default 'C',
  `date` bigint(14) default NULL,
  `layout_path` text,
  `path` text NOT NULL,
  `state` enum('OK','DRAFT','DEL') NOT NULL default 'OK',
  `author` varchar(80) NOT NULL default '',
  `name` varchar(80) NOT NULL default '',
  `mainorder` tinyint(4) NOT NULL default '0',
  `type` tinyint(4) NOT NULL default '0',
  `content_type` text NOT NULL,
  `abstract` text NOT NULL,
  `data` longblob,
  `size_x` bigint(20) NOT NULL default '0',
  `size_y` bigint(20) NOT NULL default '0',
  `date_modified` timestamp(14) NOT NULL,
  `date_created` datetime default NULL,
  `date_referenced` date default NULL,
  `time_referenced` time default NULL,
  `display_from` datetime default NULL,
  `display_until` datetime default NULL,
  PRIMARY KEY  (`id`)
) ;
