<? 
  #  This program is free software; you can redistribute it and/or modify
  #  it under the terms of the GNU General Public License as published by
  #  the Free Software Foundation; version 2 of the License.
  #
  #  This program is distributed in the hope that it will be useful,
  #  but WITHOUT ANY WARRANTY; without even the implied warranty of
  #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #  GNU General Public License for more details.
  #
  #  You should have received a copy of the GNU General Public License
  #  along with this program; if not, write to the Free Software
  #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  # $Id: ce_debug.inc,v 2.9 2009-11-17 01:08:32 peter Exp $

function ce_debug($prio,$msg,$file="",$line="")
{
  global $ce_output_ok;
  global $ce_debuglevel;
  global $ce_logfile;
  global $ce_loglevel;

  if(!isset($ce_loglevel  )) { $ce_loglevel  =99; }
  if(!isset($ce_debuglevel)) { $ce_debuglevel=10; }
  $sent_out=FALSE ;
  if ( $ce_output_ok 
       && ( $prio <= $ce_debuglevel )
       && !empty($_SERVER['PHP_AUTH_PW'] )
       ) { print $msg;
           $sent_out=TRUE ; } 
  # remove leading and trailing line breaks (i.e. whitespace):
  $msg=trim($msg);
  $msg=str_replace("&gt;",">",$msg);
  $msg=str_replace("&lt;","<",$msg);
  # # Why the heck does that not work ???
  # $msg=strstr($msg,array( '&gt;' => '>',
  #                         '&lt;' => '<'));
  # add prio to start of line
  $priostr=sprintf("%2d",$prio);
  $msg=ereg_replace("\n(.)",
                    "\n                    [".$priostr."]: ".'\1',
                    $msg);
  if ( ( $prio <= $ce_loglevel ) OR ( $sent_out )  ) 
    { 
      if($fp=fopen($ce_logfile,"a"))
        {
          fwrite($fp,strftime("%Y-%m-%d %H:%M:%S",time())." [".$priostr."]: ".$msg
                 .(empty($line) ? "" : ' at line '.$line)
                 .(empty($file) ? "" : ' in '.$file)
                 .($sent_out ? " (sent out)" : "")
                 ."\n"); 
          fclose($fp);
        }
    } 
}

function ce_error($msg,$item=NULL,$file="",$line="")
{
  global $ce_output_ok;
  if ( $ce_output_ok 
       && !empty($_SERVER['PHP_AUTH_PW']))
  { print '<font size="3" color="red">CruisEdit ERROR'
      .(empty($line) ? "" : ' at line '.$line)
      .(empty($file) ? "" : ' in '.$file)
      .': '.$msg
      .(empty($item) ? "" : " in '<A HREF=\"".ce_prefix(true)."?ce_edit_id=".$item->id."\">".(empty($item->name) ? "NONAME" : $item->name)."</A>'")
      .'</font> '; }
  ce_debug(0,"\n<!-- ERROR: ".$msg." -->");
}

function ce_warn($msg,$item=NULL,$file="",$line="")
{
  global $ce_output_ok;
  if ( $ce_output_ok 
       && !empty($_SERVER['PHP_AUTH_PW']))
  { print '<font size="3" color="red">CruisEdit WARNING'
      .(empty($line) ? "" : ' at line '.$line)
      .(empty($file) ? "" : ' in '.$file)
      .': '.$msg
      .(empty($item) ? "" : " in '<A HREF=\"".ce_prefix(true)."?ce_edit_id=".$item->id."\">".( empty($item->name) ? "NONAME" : $item->name)."</A>'")
      .'</font> '; }
  ce_debug(0,"\n<!-- WARNING: ".$msg." -->");
}

?>
