<? 
  #  This program is free software; you can redistribute it and/or modify
  #  it under the terms of the GNU General Public License as published by
  #  the Free Software Foundation; version 2 of the License.
  #
  #  This program is distributed in the hope that it will be useful,
  #  but WITHOUT ANY WARRANTY; without even the implied warranty of
  #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #  GNU General Public License for more details.
  #
  #  You should have received a copy of the GNU General Public License
  #  along with this program; if not, write to the Free Software
  #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  # $Id: ce_mod_lh.inc,v 2.1 2008-03-23 21:50:20 peter Exp $

function ce_mod_lh(&$item,&$vars)
{
  global $ce_user_vars;
  global $HTTP_GET_VARS;
  global $HTTP_SERVER_VARS;
  while( list($key,$value)=each($vars) )
    {
      ce_debug(10,"\n<!-- $key = $value -->\n");
    }
  # ------- get args
  $filename=$vars["FILE"];
  if ( "/" != substr($filename,0,1) ) 
    $filename=$_SERVER['CE_MOD_LH_BASE']."/".$filename;

  $pattern=$vars["PATTERN"];
  ce_debug(50,"\n<!-- \$pattern = ".$pattern." -->\n",
           __FILE__,__LINE__);
  $my_path_info=str_replace($item->path,"",$HTTP_SERVER_VARS["PATH_INFO"]);
  ce_debug(50,"\n<!-- \$my_path_info = ".$my_path_info." -->\n",
           __FILE__,__LINE__);
  # ------- fetch item for format
  if( isset($vars["INC_EVEN"]) && isset($vars["INC_ODD"]) )
    {
      $i_even = new ce_item($vars["INC_EVEN"],
                             isset($vars["LAYOUT"]) ? $vars["LAYOUT"] : $item->layout_class);
      $i_odd = new ce_item($vars["INC_ODD"],
                           isset($vars["LAYOUT"]) ? $vars["LAYOUT"] : $item->layout_class);
    }
  elseif( isset($vars["INCLUDE"]) )
    {
      $i_even = new ce_item($vars["INCLUDE"],
                       isset($vars["LAYOUT"]) ? $vars["LAYOUT"] : $item->layout_class);
      $i_odd =& $i_even;
    }
  else
    {
      ce_error("LH Module needs either INCLUDE= or INC_EVEN= and INC_ODD=",&$item,__FILE__,__LINE__);
    }

  # -------- this is more or less for debbuging
  $ce_user_vars["LH_FILENAME"]=$filename;
  # -------- let's do it
  if ($fd = fopen ($filename, "r") )
    {
      ## while (!feof ($fd)) {
      ##   $line = fgets($fd, 4096);
      ##   echo $line;
      ## }
      if($data = fgetcsv ($fd, 1000, "	"))
        {
          $count = count ($data);
          for ($n=0; $n<$count; $n++)
            { $varname[$n]=$data[$n];
              ce_debug(7,"\n<!-- mod_lh: found varname $varname[$n] -->");
            }
          $even=FALSE;
          while ($data = fgetcsv ($fd, 1000, "	"))
            {
              unset($matched);
              # $count = count ($data);
              if( isset($pattern) )
                $match=$pattern;
              else
                $matched=TRUE;
              for ($n=0; $n<$count; $n++)
                { 
                  ce_debug(7,"\n<!-- mod_lh: setting var \$".$varname[$n]." to ".$data[$n]." -->");
                  if(isset($data[$n]))
                    $ce_user_vars[$varname[$n]]=$data[$n];
                  else
                    unset($ce_user_vars[$varname[$n]]);
                  if( isset($HTTP_GET_VARS[$varname[$n]])
                      && ( $data[$n] != $HTTP_GET_VARS[$varname[$n]] ) )
                    {
                      $matched=FALSE;
                    }
                  isset($match) 
                    && $match=str_replace('$'.$varname[$n],$data[$n],$match);
                }
              ce_debug(50,"\n<!-- \$match = ".$match." -->",__FILE__,__LINE__);
              
              ( isset($match) && (! isset($matched) )
                && $my_path_info == $match ) && $matched=TRUE;
              if($matched)
                {
	          if( $even )
	            { $i =& $i_even ; $even=FALSE; }
                  else
                    { $i =& $i_odd ; $even=TRUE ; }
                  ce_include("INCLUDE",$i,array());
                }
            }
        }
      fclose ($fd);
    }
  else
    {
      ce_error("Opening $filename failed",&$item);
    }
}
?>
