<? 
  #  This program is free software; you can redistribute it and/or modify
  #  it under the terms of the GNU General Public License as published by
  #  the Free Software Foundation; version 2 of the License.
  #
  #  This program is distributed in the hope that it will be useful,
  #  but WITHOUT ANY WARRANTY; without even the implied warranty of
  #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #  GNU General Public License for more details.
  #
  #  You should have received a copy of the GNU General Public License
  #  along with this program; if not, write to the Free Software
  #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  # $Id: ce_parse.inc,v 2.12 2007-12-30 14:44:03 peter Exp $

function ce_parse(&$item)
{
  global $ce_main_item;
  $ce_prefix="ERROR_IN_ce_prefix";
  $ce_edit_prefix="ERROR_IN_ce_edit_prefix";
  global $ce_list_path;
  global $ce_edit;
  global $ce_showborder;
  global $ce_showdraft;
  global $ce_show_clonelink;
  global $ce_request;
  global $HTTP_SERVER_VARS;
  global $ce_user_vars;
  static $state=array(TRUE);

  ce_debug(7,"\n<!-- ce_parse(): \n",__FILE__,__LINE__);
  ce_debug(7,"\$item->layout_ref->path = '".$item->layout_ref->path."'\n",__FILE__,__LINE__);
  ce_debug(7,"\$item->path             = '".$item->path."'\n",__FILE__,__LINE__);
  ce_debug(7,"\$item->name             = '".$item->name."'\n",__FILE__,__LINE__);
  ce_debug(7,"\$item->content_type     = '".$item->content_type."'\n",__FILE__,__LINE__);
  ce_debug(7,"\$item->content_ref->path= '".$item->content_ref->path."'\n",__FILE__,__LINE__);
  ce_debug(7,"\$item->layout_class     = '".$item->layout_class."'\n",__FILE__,__LINE__);
  ce_debug(7,"ce_parse() -->\n",__FILE__,__LINE__);


  if(  "application/x-httpd-php" == $item->content_type)
    {
      eval(" ?>".$item->data."<? ");
      return;
    }
  
  if( substr(strtolower($item->content_type),0,5) != "text/" 
      AND substr(strtolower($item->content_type),0,6) != "image/" )
    # image data will be replaced by html img tag in ce_include()
    {
      print " [".$item->name."] " ;
      ce_error("Binary included from'".$item->path."'<BR>\n",$item);
      return;
    }
  
  $srch_start=0;
  $cmd_start=strpos($item->data,"<?ce",$srch_start);

  while($cmd_start !== FALSE )
    {
      if( current($state) )
        print(substr($item->data,$srch_start,$cmd_start-$srch_start));

      $cmd_end=strpos($item->data,"?>",$cmd_start);

      $tag_string=substr($item->data,
                     $cmd_start+4,
                     $cmd_end-$cmd_start-4);

      $reg_match=array();
      $tag_var=array();
      $tag_token=array();
##########################
#   1                        2                                             3                    4              5   
#'/(                )(?:                               |    )\s*(?:                                           |  )(?:  | )'
#'  \$?                 [[]"(                     )"[]]|(?:)       = *(?:                     |              ) ()    \s $ '
#'     [a-zA-Z0-9_]+         [a-zA-Z0-9_ ]+                       "(          |)(?: | ) (            )             '
#'                                                                         [^="][^"]*     " $   [^=\s][^\s]*              '
##########################

      if( preg_match_all('/(\$?[a-zA-Z0-9_]+)(?:[[]"([a-zA-Z0-9_ ]+)"[]]|(?:))\s*(?:= *(?:"([^="][^"]*|)(?:"|$)|([^\s=][^\s]*))|())(?:\s|$)/i',
                         $tag_string, $reg_match, PREG_SET_ORDER ) )
        {
          ce_debug(80,"\n<!-- New CE tag -->",__FILE__,__LINE__);
          // get the tag type by "each()", so we don't have to care about
          // it later
          list($key,$value) = each($reg_match) ;
          while(list($k,$v)=each($value))
                ce_debug(80,"\n<!--  reg_match \$value[".$k."] '".$v."' -->",__FILE__,__LINE__);
          $func=strtoupper($value[1]);
          // This might break HTML code (e.g. when PRINTVAR is used to construct URLs) !
          ce_debug(80,"\n<!--  found func $func -->",__FILE__,__LINE__);
          if( "" != $value[3].$value[4] )
            $tag_var[$func]=$value[3].$value[4];
          
          if( "$" == substr($func,0,1) )
            {
              # use $value[1] here instead of $func, as $func is uppercase, but variable may be not.
              $tag_var["VARNAME"]=substr($value[1],1);
              $func="PRINTVAR";
            }
          
          // see above: starting with the second "each()"
          while( list($key,$value) = each($reg_match) )
            {
              while(list($k,$v)=each($value))
                    ce_debug(80,"\n<!--  reg_match \$value[".$k."] '".$v."' -->",__FILE__,__LINE__);
              if( "" == $value[3].$value[4] )
                {
                  ce_debug(80,"\n<!--  Adding tag token '".$value[1]."' -->",__FILE__,__LINE__);
                  $tag_token[]=$value[1];
                }
              else
                if( empty($value[2]) )
                {
                  ce_debug(80,"\n<!--  Adding tag variable  ".
                           $value[1]." = '".$value[3].$value[4]
                           ."' -->",__FILE__,__LINE__);
                  $tag_var[strtoupper($value[1])]=$value[3].$value[4];
                }
                else
                {
                  ce_debug(80,"\n<!--  Adding tag variable  ".
                           $value[1]."[".$value[2]."] = '".$value[3].$value[4]
                           ."' -->",__FILE__,__LINE__);
                  $tag_var[strtoupper($value[1])][$value[2]]=$value[3].$value[4];
                }
            }
        }
      else
        {
          ce_error("Can't parse '&lt;?ce ".$tag_string." ?&gt;'",$item); 
        }

      // If the function name has no value by itself, the correspoding tag_var is
      // only confusing
      if( isset($tag_var[$func]) && empty($tag_var[$func]) )
        ce_error("There should be no tag variable $func with an empty value (".$tag_var[$func].")",
                $item,__FILE__,__LINE__);

      // Handle old syntax "LAYOUTCLASS" 
      if( "LAYOUTCLASS" == $func )
        {
          ce_warn("depreciated use of LAYOUTCLASS",$item);
          $func="LAYOUT";
          $tag_var["CLASS"]=$tag_var["LAYOUTCLASS"];
          unset($tag_var["LAYOUTCLASS"]);
        }

      // Execute the functions
      if( "ENDIF" == $func )
        {
          array_pop($state);
          end($state);
          ce_debug(80,"\n<!-- State set to ".(current($state) ? "TRUE" : "FALSE")." by ENDIF -->\n",__FILE__,__LINE__);
        }
      # elseif( "ELSE" == $func ) 
      #   { 
      #     end($state);
      #     $pos=key($state);
      #     $state[$pos] = (! $state[$pos] );
      #   }
      elseif( "IF" == $func ) 
        {
          if(current($state))
            {
              if(isset($tag_var[$func]))
                ce_warn("Tag variable $func should not have a value (".$tag_var[$func].")",
                        $item,__FILE__,__LINE__);
              if( "TRUE" == $tag_token[0] )
                    $state[]=TRUE;
              elseif( "FALSE" == $tag_token[0] )
                    $state[]=FALSE;
              elseif( "$" == substr($tag_token[0],0,1) )
                {
                  ce_debug(80,"\n<!-- Checking whether $".substr($tag_token[0],1)." is set -->\n",__FILE__,__LINE__);
                  if( empty($ce_user_vars[substr($tag_token[0],1)]) )
                    $state[]=FALSE;
                  else
                    $state[]=TRUE;
                }
              else
                {
                  list($key,$val)=each($tag_token);
                  if ( $ce_user_vars[substr($key,1)] == $val )
                    $state[]=TRUE;
                  else
                    $state[]=FALSE;
                }
            }
          else
            {
              $state[]=FALSE;
            }
          end($state);
          ce_debug(80,"\n<!-- State set to ".(current($state) ? "TRUE" : "FALSE")." by IF -->\n",__FILE__,__LINE__);
        }
      elseif( ! current($state) ) 
        { 
          ce_debug(80,"\n<!-- Execution suppressed by IF -->\n",__FILE__,__LINE__);
        }
      elseif( "INCLUDE" == $func ) 
        { 
          ce_include("INCLUDE",new ce_item($tag_var["INCLUDE"],
                                           isset($tag_var["LAYOUT"]) ? $tag_var["LAYOUT"] : ($item->layout_class)),
                                           &$tag_var);   
        }
      elseif( "INCLUDELIST" == $func ) 
        { 
          list($includelist_path,$includelist_count)
            =explode( "," , $tag_var["INCLUDELIST"] );
          if( isset($includelist_count )) 
            ce_warn("depreciated use of INCLUDELIST args",$item);
          if( isset($tag_var["MAX"]) ) $includelist_count=$tag_var["MAX"] ;
          if( empty($includelist_count) ) $includelist_count=-1 ;
          if( isset($tag_var["SORT_BY"]) )
            {
              $sort_col=$tag_var["SORT_BY"];
              if( "-" == substr ($sort_col, 0,1) ) { $sort_by[substr($sort_col,1)]="DESC"; }
              else                                 { $sort_by[$sort_col]="ASC"; }
            }
          $sort_by["DATE_MODIFIED"]="DESC";
          $list_item=& new ce_list_item($includelist_path,
                                        isset($tag_var["LAYOUT"]) ? $tag_var["LAYOUT"]: ($item->layout_class),
                                        NULL,$sort_by);
          # remember value of global show_clonelink:
          $show_clonelink_org=$ce_show_clonelink;
          $ce_show_clonelink=TRUE;
          $paths_seen=array();
          while( $list_item->next() && ( $includelist_count != 0 ) )
            {
              if(in_array($list_item->path,$paths_seen)) continue;
              # The folling lines will only be executed, if
              # the path has not been seen before
              $includelist_count--;
              ce_include("INCLUDE",$list_item,&$tag_var);
              $paths_seen[]=$list_item->path;
            }
          # restore value of global show_clonelink:
          $ce_show_clonelink=$show_clonelink_org;
        }
      elseif( "MODULE" == $func ) 
        { 
          $module_func="ce_mod_".$tag_var["MODULE"]; 
          $module_func($item,&$tag_var);
        }
      elseif( "LAYOUT" == $func ) 
        { 
          if( isset($tag_var["CLASS"]) )
            {
              ce_debug(5,"\n<!--Layout Class:'".$tag_var["CLASS"]."'-->"); 
              $item->layout_class=$tag_var["CLASS"];
            }
        }
      elseif( "EDIT" == $func )
        {
          ce_debug(9,"\n<!-- EDIT LINK='".$tag_var["LINK"]."'\n"
                   ."          LABEL='".$tag_var["LABEL"]."' -->\n");
          if( isset($ce_edit) && empty($GLOBALS["ce_edit_display_item"]) ) 
            {
              print "[";
              if( "edit:self" == strtolower($tag_var["LINK"]) )
                {
                  print('<A HREF="'
                        .ce_prefix(TRUE).$HTTP_SERVER_VARS['PATH_INFO']
                        .'?ce_edit_display_item='.$item->display_item_no().'">edit</A>');
                  $edit_label=$item->name;
                  $item->edit_link_shown=TRUE;
                }
              elseif( "fulledit:self" == strtolower($tag_var["LINK"]) )
                {
                  print('<A HREF="'
                        .ce_prefix(TRUE)
                        .'?ce_edit_id='.$item->id.'">change</A>');
                  $edit_label=$item->name;
                  $item->edit_link_shown=TRUE;
                }
              elseif(! isset($item->content_ref) )
                { ce_warn("EDIT tag without reference to content",$item); }
              elseif( "edit:content" == strtolower($tag_var["LINK"]) )
                {
                  print('<A HREF="'
                        .ce_prefix(TRUE).$HTTP_SERVER_VARS['PATH_INFO']
                        .'?ce_edit_display_item='.$item->content_ref->display_item_no().'">edit</A>');
                  $edit_label=$item->content_ref->name;
                  $item->content_ref->edit_link_shown=TRUE;
                }
              elseif( "fulledit:content" == strtolower($tag_var["LINK"]) )
                {
                  print('<A HREF="'
                        .ce_prefix(TRUE)
                        .'?ce_edit_id='.$item->content_ref->id.'">change</A>');
                  $edit_label=$item->content_ref->name;
                  $item->content_ref->edit_link_shown=TRUE;
                }
              elseif( "clone:content" == strtolower($tag_var["LINK"]) )
                {
                  print('<A HREF="'
                        .ce_prefix(TRUE)
                        .'?ce_clone_id='.$item->content_ref->id.'">clone</A>');
                  $edit_label=$item->content_ref->name;
                  $item->content_ref->edit_link_shown=TRUE;
                }
              if( "none" != strtolower($tag_var["LABEL"]) )
                {
                  if( isset($tag_var["LABEL"]) ) 
                    $edit_label=$tag_var["LABEL"];
                  print '&quot;'.$edit_label.'&quot';
                }
              print ']';
            }
        }
      elseif( "REF" == $func ) 
        { 
          print(ce_prefix(isset($ce_edit)).$tag_var["REF"]);
        }
      elseif( "URL" == $func )
        {
          print(ce_prefix(isset($ce_edit)).$item->content_ref->path);
        }
      elseif( "AUTHOR" == $func )
        {
	  ce_debug(50,"\n<!--Author of ".$item->content_ref->path." -->");
          print($item->get_content_author());
        }
      elseif( "LAST_MODIFIED" == $func )
        {          
          print(strftime("%x %T",$item->get_content_last_modified()));
        }
      elseif( "DATE_CREATED" == $func )
        {
          print(strftime("%x",$item->get_content_date_created()));
        }
      elseif( "TITLE" == $func )
        {
          print($ce_request->name);
        }
      elseif( "NAME" == $func )
        {
          print($item->get_content_name());
        }
      elseif( "HEADER" == $func)
        {
          if( ! empty($_SERVER['PHP_AUTH_PW']) )
            {
              print('<link rel="alternate" 
                     href="'.ce_prefix(!isset($ce_edit)).$HTTP_SERVER_VARS['PATH_INFO'].'"
                     title="'.(isset($ce_edit) ? 'Hide' : 'Show').' Edit Links">'."\n");
              print('<link rel="alternate" 
                     href="'.ce_prefix(TRUE).$HTTP_SERVER_VARS['PATH_INFO'].'?ce_edit_id='.$ce_request->id.'"
                     title="Edit &quot;'.$ce_request->name.'&quot;">'."\n");
             
              if( $ce_showborder )
                {
                  print('<link rel="alternate" 
                     href="'.ce_prefix(isset($ce_edit)).$HTTP_SERVER_VARS['PATH_INFO'].'?ce_showborder=0"
                     title="Without Structure">'."\n");}
              else
                {
                  print('<link rel="alternate" 
                     href="'.ce_prefix(isset($ce_edit)).$HTTP_SERVER_VARS['PATH_INFO'].'?ce_showborder=1"
                     title="Show Structure">'."\n");}

              if( $ce_showdraft )
                {
                  print('<link rel="alternate" 
                     href="'.ce_prefix(isset($ce_edit)).$HTTP_SERVER_VARS['PATH_INFO'].'?ce_showdraft=0"
                     title="Online Version">'."\n");}
              else
                {
                  print('<link rel="alternate" 
                     href="'.ce_prefix(isset($ce_edit)).$HTTP_SERVER_VARS['PATH_INFO'].'?ce_showdraft=1"
                     title="Show Draft">'."\n");}

              print('<link rel="bookmark" 
                     href="'.$ce_list_path.'"
                     title="List All">'."\n");

            }
        }
      elseif( "ICONLINK" == $func )
        {

          $pagedir=preg_replace(":/[^/]*$:","/",ce_prefix(FALSE).$HTTP_SERVER_VARS['PATH_INFO']);
          $relpath=preg_replace(":^".$pagedir.":","",ce_prefix(FALSE).$item->content_ref->path);
          print('<A HREF="'.$relpath.'">');
          print('<IMG SRC="'.$relpath.'_i.jpg"
                      ALT="[Bild:'.$item->get_content_name().']"
                      TITLE="'.$item->get_content_name().'">');
          print('</A>');
        }
      elseif( "ABSTRACT" == $func )
        {
          # ce_include("ABSTRACT",$item->get_last_content_ref(),&$tag_var);
          ce_include("ABSTRACT",$item->content_ref,&$tag_var);
          # print($item->get_content_abstract());
         }
      elseif( "CONTENT" == $func )
        {
          ce_include("CONTENT",$item->content_ref,&$tag_var);
        }
      elseif( "SET" == $func )
        {
          if(isset($tag_var[$func]))
            ce_warn("Tag variable $func should not have a value (".$tag_var[$func].")",
                    $item,__FILE__,__LINE__);
          while( list($key,$value) = each($tag_var) )
            {
              ce_debug(80,"\n<!-- trying to set ".$key." -->\n");
              if( "$" == substr($key,0,1) )
                {
                  ce_debug(7,"\n<!-- Setting $key to $value -->\n");
                  $ce_user_vars[substr($key,1)]=$value;
                }
              else
                {
                  ce_error("Syntax Error: Varname $key has to start with '$'",$item);
                }
            }
        }
      elseif( "PRINTVAR" == $func )
        {
          # Note: debuging output at this point my break HTML code! 
          ce_debug(80,"\n<!-- trying to print \$".$tag_var["VARNAME"]." -->\n");
          print $ce_user_vars[$tag_var["VARNAME"]];
        }
      else
        {
          ce_error("Unknown ce tag '&lt;?ce ".$tag_string." ?&gt;'",$item); 
        }
      $srch_start=$cmd_end+2;
      # print("\n<!--srch_start=$srch_start-->");
      $cmd_start=strpos($item->data,"<?ce",$srch_start);
      # print("\n<!--cmd_start=$cmd_start-->");
    }
  if(count($state) != 1)
    {
      ce_warn("IF statements do not match ENDIFs",$item,__FILE__,__LINE__);
      $state=array(TRUE);
    }
  # print("\n<!--START REMAINDER-->");
  print(substr($item->data,$srch_start));


}
?>
